package ru.pricepulse.parsingservice.ozon_parser.service;

import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.springframework.stereotype.Service;
import ru.pricepulse.parsingservice.ozon_parser.service.dto.ParsedData;
import ru.pricepulse.parsingservice.ozon_parser.service.messaging.ParsedDataProducer;

@Slf4j
@Service
@RequiredArgsConstructor
public class DataParser {

    private final ParsedDataProducer queueProducer;

    public boolean pageHasData(String html) {
        Document doc = Jsoup.parse(html);
        return doc.select("div[data-widget=searchResultsError]").isEmpty();
    }

    public void parseAndQueueData(String html) {
        Document doc = Jsoup.parse(html);
        for (Element item : doc.select(".item-class")) {
            String title = item.select(".item-title").text();
            String price = item.select(".item-price").text();

            ParsedData parsedData = new ParsedData();
            log.info("Попытка отправить данные в очередь");
            queueProducer.sendToQueue(parsedData);
            log.info("Данные успешно отправлены в очередь");
        }
    }

}
